glibmm: Gio::ThemedIcon Class Reference

glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::ThemedIcon Class Reference

Icon theming support. More...

`#include <giomm/themedicon.h>`

Inheritance diagram for Gio::ThemedIcon:
[legend]

## Public Member Functions
| ThemedIcon (ThemedIcon&& src) noexcept
ThemedIcon& | operator= (ThemedIcon&& src) noexcept
| ~ThemedIcon () noexcept override
GThemedIcon* | gobj ()
| Provides access to the underlying C GObject. More...
const GThemedIcon* | gobj () const
| Provides access to the underlying C GObject. More...
GThemedIcon* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | prepend_name (const std::string& iconname)
| Prepend a name to the list of icons from within icon. More...
void | append_name (const std::string& iconname)
| Append a name to the list of icons from within icon. More...
Glib::StringArrayHandle | get_names () const
| Gets the names of icons from within icon. More...
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_names () const
| A `nullptr`-terminated array of icon names. More...
Glib::PropertyProxy_ReadOnly< bool > | property_use_default_fallbacks () const
| Whether to use the default fallbacks found by shortening the icon name at '-' characters. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::Icon
| Icon (Icon&& src) noexcept
Icon& | operator= (Icon&& src) noexcept
| ~Icon () noexcept override
GIcon* | gobj ()
| Provides access to the underlying C GObject. More...
const GIcon* | gobj () const
| Provides access to the underlying C GObject. More...
guint | hash () const
| Gets a hash for an icon. More...
std::string | to_string () const
| Generates a textual representation of icon that can be used for serialization such as when passing icon to a different process or saving it to persistent storage. More...
bool | equal (const Glib::RefPtr< Icon >& other) const
Glib::VariantBase | serialize () const
| Serializes a Icon into a Variant. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ThemedIcon > | create (const std::string& iconname, bool use_default_fallbacks=false)
| Creates a new themed icon for iconname, and optionally all the names that can be created by shortening iconname at '-' characters. More...
Static Public Member Functions inherited from Gio::Icon
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Icon > | create (const std::string& str)
| Generate an Icon instance from str. More...
static Glib::RefPtr< Icon > | deserialize (const Glib::VariantBase& value)
| Deserializes a Icon previously serialized using g_icon_serialize(). More...

## Protected Member Functions
| ThemedIcon (const std::string& iconname, bool use_default_fallbacks=false)
| Creates a new themed icon for iconname, and optionally all the names that can be created by shortening iconname at '-' characters. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)
Protected Member Functions inherited from Gio::Icon
| Icon ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::ThemedIcon > | wrap (GThemedIcon* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::Icon
Glib::RefPtr< Gio::Icon > | wrap (GIcon* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Icon theming support.

ThemedIcon is an implementation of Gio::Icon that supports icon themes. ThemedIcon contains a list of all of the icons present in an icon theme, so that icons can be looked up quickly. ThemedIcon does not provide actual pixmaps for icons, just the icon names. Ideally something like Gtk::IconTheme::choose_icon() should be used to resolve the list of names so that fallback icons work nicely with themes that inherit other themes.

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ ThemedIcon() [1/2]

Gio::ThemedIcon::ThemedIcon | ( | ThemedIcon&& | src | ) |
| noexcept

## ◆ ~ThemedIcon()

Gio::ThemedIcon::~ThemedIcon | ( |  | ) |
| overridenoexcept

## ◆ ThemedIcon() [2/2]

Gio::ThemedIcon::ThemedIcon | ( | const std::string & | iconname,
|  | bool | use_default_fallbacks = `false`
| ) |  |
| explicitprotected

Creates a new themed icon for iconname, and optionally all the names that can be created by shortening iconname at '-' characters.

Parameters

  iconname | A string containing an icon name.
  use_default_fallbacks | Whether to use all the names that can be created by shortening iconname at '-' characters.

## Member Function Documentation

## ◆ append_name()

void Gio::ThemedIcon::append_name | ( | const std::string & | iconname | ) |

Append a name to the list of icons from within icon.

Note that doing so invalidates the hash computed by prior calls to g_icon_hash().

Parameters

  iconname | Name of icon to append to list of icons from within icon.

## ◆ create()

static Glib::RefPtr<ThemedIcon> Gio::ThemedIcon::create | ( | const std::string & | iconname,
|  | bool | use_default_fallbacks = `false`
| ) |  |
| static

Creates a new themed icon for iconname, and optionally all the names that can be created by shortening iconname at '-' characters.

For example

Glib::RefPtr<Gio::ThemedIcon> icon = Gio::ThemedIcon::create("gnome-dev-cdrom-audio", true);

is equivalent to

Glib::RefPtr<Gio::ThemedIcon> icon = Gio::ThemedIcon::create("gnome-dev-cdrom-audio", false);
icon->append_name("gnome-dev-cdrom");
icon->append_name("gnome-dev");
icon->append_name("gnome");

Parameters

  iconname | A string containing an icon name.
  use_default_fallbacks | Whether to use all the names that can be created by shortening iconname at '-' characters.

## ◆ get_names()

Glib::StringArrayHandle Gio::ThemedIcon::get_names | ( |  | ) | const

Gets the names of icons from within icon.

Returns
  A list of icon names.

## ◆ get_type()

static GType Gio::ThemedIcon::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GThemedIcon* Gio::ThemedIcon::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GThemedIcon* Gio::ThemedIcon::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GThemedIcon* Gio::ThemedIcon::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

ThemedIcon& Gio::ThemedIcon::operator= | ( | ThemedIcon&& | src | ) |
| noexcept

## ◆ prepend_name()

void Gio::ThemedIcon::prepend_name | ( | const std::string & | iconname | ) |

Prepend a name to the list of icons from within icon.

Note that doing so invalidates the hash computed by prior calls to g_icon_hash().

Since glibmm 2.18:

Parameters

  iconname | Name of icon to prepend to list of icons from within icon.

## ◆ property_names()

Glib::PropertyProxy_ReadOnly< std::vector<Glib::ustring> > Gio::ThemedIcon::property_names | ( |  | ) | const

A `nullptr`-terminated array of icon names.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_default_fallbacks()

Glib::PropertyProxy_ReadOnly< bool > Gio::ThemedIcon::property_use_default_fallbacks | ( |  | ) | const

Whether to use the default fallbacks found by shortening the icon name at '-' characters.

If the "names" array has more than one element, ignores any past the first.

For example, if the icon name was "gnome-dev-cdrom-audio", the array would become

[C example ellipted]

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::ThemedIcon > wrap | ( | GThemedIcon * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.